/** ###################################################################
**      Filename    : PDD_Includes.h
**      Processor   : SKEAZ128MLK4
**      Version     : 1.0
** 
**     Copyright : 1997 - 2015 Freescale Semiconductor, Inc. 
**     All Rights Reserved.
**     
**     Redistribution and use in source and binary forms, with or without modification,
**     are permitted provided that the following conditions are met:
**     
**     o Redistributions of source code must retain the above copyright notice, this list
**       of conditions and the following disclaimer.
**     
**     o Redistributions in binary form must reproduce the above copyright notice, this
**       list of conditions and the following disclaimer in the documentation and/or
**       other materials provided with the distribution.
**     
**     o Neither the name of Freescale Semiconductor, Inc. nor the names of its
**       contributors may be used to endorse or promote products derived from this
**       software without specific prior written permission.
**     
**     THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
**     ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
**     WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
**     DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
**     ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
**     (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
**     LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
**     ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
**     (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
**     SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**     
**     http: www.freescale.com
**     mail: support@freescale.com
** ###################################################################*/
/*!
** @file PDD_Includes.h                                                  
** @version 01.00
*/         
/*!
**  @addtogroup PDD_Includes_module PDD_Includes module documentation
**  @{
*/         

#ifndef __PDD_Includes_H
#define __PDD_Includes_H

/* MODULE PDD_Includes.h */

#ifdef __cplusplus
extern "C" {
#endif

#include "ADC_PDD.h"
#include "CMP_PDD.h"
#include "CRC_PDD.h"
#include "FTM_PDD.h"
#include "FTMRE_PDD.h"
#include "GPIO_PDD.h"
#include "I2C_PDD.h"
#include "IRQ_PDD.h"
#include "KBI_PDD.h"
#include "MCM_PDD.h"
#include "MSCAN_PDD.h"
#include "NVIC_PDD.h"
#include "PIT_PDD.h"
#include "PMC_PDD.h"
#include "PORT_PDD.h"
#include "PWT_PDD.h"
#include "RTC0_PDD.h"
#include "SCB_PDD.h"
#include "SIM_PDD.h"
#include "SPI_PDD.h"
#include "SysTick_PDD.h"
#include "UART_PDD.h"
#include "WDOG_PDD.h"

#ifdef __cplusplus
}
#endif

/* END PDD_Includes.h */

#endif /* __PDD_Includes_H */

/*!
** @}
*/
/*
** ###################################################################
**
**     This file is a part of Processor Expert static initialization
**     library for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/